//! Intrinsics for panic handling

use core::arch::asm;
use core::panic::PanicInfo;

use crate::println;

#[lang = "eh_personality"]
#[no_mangle]
pub extern "C" fn rust_eh_personality() {}

/// Required to handle panics
#[panic_handler]
#[no_mangle]
pub fn rust_begin_unwind(info: &PanicInfo<'_>) -> ! {
	unsafe {
		println!("TETRIS PANIC:\n{}", info);
		loop {
			asm!("hlt");
		}
	}
}

#[allow(non_snake_case)]
#[no_mangle]
/// Required to handle panics
pub extern "C" fn _Unwind_Resume() -> ! {
	loop {
		unsafe {
			asm!("hlt");
		}
	}
}
